//+------------------------------------------------------------------+
//|                                      Consecutive_Bulls_Bears.mq4 |
//|                                                             dags |
//|                                                                  |
//| This indicator designed to search for consecutive Bull or Bear   |
//| candles, user input to select amount of consecutive candles and  |
//| option to sound Alert.                                           |
//+------------------------------------------------------------------+

#property copyright "dags"
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_width1 2
#property indicator_width2 2

extern int Consecutive_Bulls = 7; // How many consecutive Bulls
extern int Consecutive_Bears = 7; // How many consecutive Bears

extern bool SoundAlert=true; // Do you want to Sound Alert?

double downArrow[];
double upArrow[];
int Bull_count = 0;
int Bear_count = 0;
static datetime BullTime;
static datetime BearTime;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
//--- indicator buffers mapping
   SetIndexBuffer(0,downArrow);
   SetIndexArrow (0,226);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexLabel(0,"Consecutive Bear Candles" );
//----
   SetIndexBuffer(1,upArrow);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow (1,225);
   SetIndexLabel(1,"Consecutive BULL Candles" );
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---

   int counted_bars=IndicatorCounted();
   int limit =Bars-counted_bars;
   if ( limit == Bars ) limit--;
   for(int i = 1;i<limit;i++){
   
//--- Check for BULL Candle
      if (Close[i+1]>Open[i+1]){
         Bull_count +=1;                                             // increment Bull Candle count
         if(Bull_count >= Consecutive_Bulls ){
            upArrow[i-Consecutive_Bulls+2] = Low[i-Consecutive_Bulls+2];                                 // put Up Arrow on chart
            if(SoundAlert && Time[0] != BullTime )
               {
                  BullTime = Time[0];
                  Alert(Symbol()," ", Bull_count , " Consecutive BULL Candles" );
               }
          }//end if
         }
      else Bull_count = 0;                                           // if Bear candle then reset Bull candle count

//--- Check for BULL Candle
      if (Close[i+1]<=Open[i+1]){
         Bear_count +=1;                                             // increment Bear Candle count
         if(Bear_count >= Consecutive_Bears){
            downArrow[i-Consecutive_Bears+2] = High[i-Consecutive_Bears+2];                              // put Down Arrow on chart
            if(SoundAlert && Time[0] != BearTime)
            {
               BearTime = Time[0];
               Alert(Symbol()," ", Bear_count , " Consecutive Bear Candles" );
            }
          }//end if
         }
      else Bear_count = 0;                                           // if Bear candle then reset Bull candle count
   
   }// end for


//--- return value of prev_calculated for next call
   return(rates_total);
  }
  
int deinit()
//---- Remove all objects from screen.
   {
   ObjectDelete("upArrow");
   ObjectDelete("downArrow");
   
      return(0);

   }
//+------------------------------------------------------------------+
